SystemOrganization addCategory: #'Phidget-VMMaker-Plugins'!

SmartSyntaxInterpreterPlugin subclass: #PhidgetPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-VMMaker-Plugins'!

!PhidgetPlugin commentStamp: 'pt 5/3/2009 13:55' prior: 0!
A PhidgetPlugin is a plugin to enable the use of Phidgets (For more information about Phidgets see www.phidgets.com).

Instance Variables: - none -
!

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/6/2009 17:20'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:58'!
requiresCrossPlatformFiles
	"default is ok for most, any plugin needing platform specific files must say so"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:57'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^true! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'fs 7/5/2009 20:46'!
cStringOf: byteArray
	
	self returnTypeC: 'char* '.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: byteArray ) not and:
		 [ ( interpreterProxy isBytes: byteArray ) ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(char*)(byteArray + 4)'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 18:14'!
initialiseModule
	"Initialise the module"

	self export: true.
	self cCode: 'phidgetPlugin_Initialise()'.
	^ 1! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 11:46'!
phidgetIdOf: byteArray
	"Return the PhidgetId of the given Smalltalk bytes object, or nil if oop is not a PhidgetId."

	self returnTypeC: 'PhidgetId* '.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: byteArray ) not and:
		 [ ( interpreterProxy isBytes: byteArray ) and:
		 [ ( interpreterProxy slotSizeOf: byteArray ) = ( self cCode: 'sizeof(PhidgetId)' ) ] ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(PhidgetId*)(byteArray + 4)'! !

!PhidgetPlugin methodsFor: 'Phidget: Accelerometer' stamp: 'sp 6/18/2009 17:12'!
primAccelerometerCreate

	self primitive: 'primAccelerometerCreate' parameters: #().
	^ self cCode: 'phidgetAccel_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget: Advanced Servo' stamp: 'sp 6/26/2009 05:56'!
primAdvancedServoCreate

	self primitive: 'primAdvancedServoCreate' parameters: #().
	^ self cCode: 'phidgetAdvServo_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 14:29'!
primClose: phidgetIdArray

	| phidgetId |
	self primitive: 'primClose' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_Close(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:43'!
primGetAdvancedServoAcceleration: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoAcceleration' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetAcceleration(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:43'!
primGetAdvancedServoAccelerationMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoAccelerationMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetAccelerationMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:43'!
primGetAdvancedServoAccelerationMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoAccelerationMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetAccelerationMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:43'!
primGetAdvancedServoCurrent: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoCurrent' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetCurrent(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:50'!
primGetAdvancedServoVelocity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocity(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:50'!
primGetAdvancedServoVelocityLimit: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocityLimit' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocityLimit(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:54'!
primGetAdvancedServoVelocityMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocityMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocityMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:54'!
primGetAdvancedServoVelocityMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAdvancedServoVelocityMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_GetVelocityMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'lk 6/15/2009 15:56'!
primGetAnalogSensorValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAnalogSensorValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAnalogSensor_GetValue(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 22:04'!
primGetAxisAcceleration: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAcceleration' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAxis_GetAcceleration(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 22:05'!
primGetAxisAccelerationMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAccelerationMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAxis_GetAccelerationMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 22:05'!
primGetAxisAccelerationMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetAxisAccelerationMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompAxis_GetAccelerationMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'lk 6/15/2009 15:57'!
primGetDigitalInputValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetDigitalInputValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalInput_GetValue(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 6/15/2009 15:57'!
primGetDigitalOutputValue: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetDigitalOutputValue' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_GetValue(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 17:02'!
primGetDoubleSensitivity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetIndexedDoubleSensitivity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetComponent_GetIndexedDoubleSensitivity(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 17:01'!
primGetIntegerSensitivity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetIndexedIntegerSensitivity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetComponent_GetIndexedIntegerSensitivity(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:25'!
primGetLastRFIDTag: phidgetIdArray

	| phidgetId tagArrayOop tagArray |
	self primitive: 'primGetLastRFIDTag' parameters: #(Oop).
	self var: #tagArray type: 'char *'.
	self var: #phidgetId type: 'PhidgetId'.
	
	tagArrayOop := interpreterProxy
		instantiateClass: interpreterProxy classByteArray
		indexableSize: 5.
	tagArray := self cCode: '(char *) (tagArrayOop + 4)'.
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetCompRFID_GetLastTag(phidgetId, tagArray)' ].
	^ tagArrayOop! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/24/2009 14:20'!
primGetMotorAcceleration: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorAcceleration' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompMotor_GetAcceleration(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/24/2009 14:21'!
primGetMotorAccelerationMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorAccelerationMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompMotor_GetAccelerationMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/24/2009 14:21'!
primGetMotorAccelerationMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorAccelerationMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompMotor_GetAccelerationMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/25/2009 12:26'!
primGetMotorCurrent: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorCurrent' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompMotor_GetCurrent(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/24/2009 14:42'!
primGetMotorVelocity: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetMotorVelocity' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompMotor_GetVelocity(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:26'!
primGetServoPosition: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPosition' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetPosition(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 23:13'!
primGetServoPositionMax: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPositionMax' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetPositionMax(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/16/2009 11:54'!
primGetServoPositionMin: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primGetServoPositionMin' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy floatObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetPositionMin(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'fs 7/5/2009 20:57'!
primGetTextDisplayColumnCount: phidgetIdArray

	| phidgetId |
	self primitive: 'primGetTextDisplayColumnCount' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextDisplay_ColumnCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'fs 7/5/2009 20:57'!
primGetTextDisplayRowCount: phidgetIdArray

	| phidgetId |
	self primitive: 'primGetTextDisplayRowCount' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextDisplay_RowCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:10'!
primGetTextLCDContrast: phidgetIdArray

	| phidgetId |
	self primitive: 'primGetTextLCDContrast' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_GetContrast(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:26'!
primHasRFIDTag: phidgetIdArray

	| phidgetId |
	self primitive: 'primHasRFIDTag' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_HasTag(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget: Interface Kit' stamp: 'lk 6/15/2009 17:14'!
primInterfaceKitCreate

	self primitive: 'primInterfaceKitCreate' parameters: #().
	^ self cCode: 'phidgetIfKit_Create()'! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:43'!
primIsAdvancedServoSpeedRampingOn: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primIsAdvancedServoSpeedRampingOn' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_IsSpeedRampingOn(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 13:01'!
primIsAttached: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsAttached' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_isAttached(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:26'!
primIsRFIDAntennaOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsRFIDAntennaOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_IsAntennaOn(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:27'!
primIsServoEngaged: phidgetIdArray at: index

	| phidgetId |
	self primitive: 'primIsServoEngaged' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_IsEngaged(phidgetId, index)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Simple LED' stamp: 'lk 6/15/2009 20:38'!
primIsSimpleLEDOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsSimpleLEDOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompSimpleLED_IsOn(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:00'!
primIsTextLCDBacklightOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsTextLCDBacklightOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_IsBacklightOn(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:06'!
primIsTextLCDCursorBlinking: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsTextLCDCursorBlinking' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_IsCursorBlinking(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:04'!
primIsTextLCDCursorOn: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsTextLCDCursorOn' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_IsCursorOn(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 13:01'!
primIsValid: phidgetIdArray

	| phidgetId |
	self primitive: 'primIsValid' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_isValid(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 21:00'!
primLastError

	self primitive: 'primLastError' parameters: #( ).
	
	^ interpreterProxy integerObjectOf:
		( self cCode: 'phidget_LastError()' )! !

!PhidgetPlugin methodsFor: 'Phidget: Motor Control' stamp: 'sp 6/24/2009 11:55'!
primMotorControlCreate

	self primitive: 'primMotorControlCreate' parameters: #().
	^ self cCode: 'phidgetMotCon_Create()'! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'lk 6/15/2009 15:56'!
primNumAnalogSensors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumAnalogSensors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAnalogSensor_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/18/2009 17:04'!
primNumAxes: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumAxes' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAxis_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'lk 6/15/2009 15:57'!
primNumDigitalInputs: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumDigitalInputs' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalInput_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 6/15/2009 15:57'!
primNumDigitalOutputs: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumDigitalOutputs' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/24/2009 14:22'!
primNumMotors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumMotors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompMotor_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:21'!
primNumServoMotors: phidgetIdArray

	| phidgetId |
	self primitive: 'primNumServoMotors' parameters: #(Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_GetCount(phidgetId)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 13:58'!
primOpen: phidgetIdArray withSerial: serial

	| phidgetId |
	self primitive: 'primOpen' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidget_Open(phidgetId, serial)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget: RFID' stamp: 'lk 6/15/2009 21:04'!
primRFIDCreate

	self primitive: 'primRFIDCreate' parameters: #().
	^ self cCode: 'phidgetRFID_Create()'! !

!PhidgetPlugin methodsFor: 'Phidget: Servo' stamp: 'lk 6/15/2009 22:19'!
primServoCreate

	self primitive: 'primServoCreate' parameters: #().
	^ self cCode: 'phidgetServo_Create()'! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:42'!
primSetAdvancedServoAcceleration: phidgetIdArray at: index to: acceleration

	| phidgetId floatAcceleration |
	self primitive: 'primSetAdvancedServoAcceleration' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatAcceleration := interpreterProxy floatValueOf: acceleration.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetAcceleration(phidgetId, index, floatAcceleration)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:49'!
primSetAdvancedServoPositionMax: phidgetIdArray at: index to: positionMax

	| phidgetId floatPositionMax |
	self primitive: 'primSetAdvancedServoPositionMax' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatPositionMax := interpreterProxy floatValueOf: positionMax.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetPositionMax(phidgetId, index, floatPositionMax)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:49'!
primSetAdvancedServoPositionMin: phidgetIdArray at: index to: positionMin

	| phidgetId floatPositionMin |
	self primitive: 'primSetAdvancedServoPositionMin' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatPositionMin := interpreterProxy floatValueOf: positionMin.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetPositionMin(phidgetId, index, floatPositionMin)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 09:44'!
primSetAdvancedServoSpeedRampingOn: phidgetIdArray at: index to: state

	| phidgetId |
	self primitive: 'primSetAdvancedServoSpeedRampingOn' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetSpeedRampingOn(phidgetId, index, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/29/2009 10:55'!
primSetAdvancedServoVelocityLimit: phidgetIdArray at: index to: velocityLimit

	| phidgetId floatVelocityLimit |
	self primitive: 'primSetAdvancedServoVelocityLimit' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatVelocityLimit := interpreterProxy floatValueOf: velocityLimit.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetVelocityLimit(phidgetId, index, floatVelocityLimit)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'lk 6/15/2009 15:57'!
primSetDigitalOutputValue: phidgetIdArray at: index to: value

	| phidgetId |
	self primitive: 'primSetDigitalOutputValue' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_SetValue(phidgetId, index, value)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 21:03'!
primSetDoubleSensitivity: phidgetIdArray at: index to: value

	|floatSensitivity phidgetId|
	self primitive: 'primSetIndexedDoubleSensitivity' parameters: #(Oop SmallInteger Oop ).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatSensitivity type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatSensitivity := interpreterProxy floatValueOf: value.
	
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetComponent_SetIndexedDoubleSensitivity(phidgetId, index, floatSensitivity)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component common' stamp: 'sp 6/18/2009 16:58'!
primSetIntegerSensitivity: phidgetIdArray at: index to: value

	| phidgetId |
	self primitive: 'primSetIndexedIntegerSensitivity' parameters: #(Oop SmallInteger SmallInteger ).
	self var: #phidgetId type: 'PhidgetId'.

	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetComponent_SetIndexedIntegerSensitivity(phidgetId, index, value)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/29/2009 09:30'!
primSetMotorAcceleration: phidgetIdArray at: index to: acceleration

	| phidgetId floatAcceleration |
	self primitive: 'primSetMotorAcceleration' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatAcceleration := interpreterProxy floatValueOf: acceleration.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompMotor_SetAcceleration(phidgetId, index, floatAcceleration)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/29/2009 09:30'!
primSetMotorVelocity: phidgetIdArray at: index to: velocity

	| phidgetId floatVelocity |
	self primitive: 'primSetMotorVelocity' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatVelocity := interpreterProxy floatValueOf: velocity.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompMotor_SetVelocity(phidgetId, index, floatVelocity)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 20:26'!
primSetRFIDAntennaState: phidgetIdArray to: anInteger

	| phidgetId |
	self primitive: 'primSetRFIDAntennaState' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_SetAntennaState(phidgetId, anInteger)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/26/2009 06:39'!
primSetSemaphoreIndexAdvancedServoCurrentChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAdvancedServoCurrentChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetSemaphoreIndex_CurrentChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Advanced Servo Motor' stamp: 'sp 6/26/2009 06:40'!
primSetSemaphoreIndexAdvancedServoVelocityChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAdvancedServoVelocityChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAdvancedServoMotor_SetSemaphoreIndex_VelocityChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Analog Sensor' stamp: 'sp 6/22/2009 11:58'!
primSetSemaphoreIndexAnalogSensorChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAnalogSensorChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAnalogSensor_SetSemaphoreIndex_ValueChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 12:45'!
primSetSemaphoreIndexAttach: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAttach' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidget_SetSemaphoreIndex_Attach(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Axis' stamp: 'sp 6/22/2009 11:58'!
primSetSemaphoreIndexAxisChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexAxisChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompAxis_SetSemaphoreIndex_AccelerationChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 12:45'!
primSetSemaphoreIndexDetach: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDetach' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidget_SetSemaphoreIndex_Detach(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Input' stamp: 'sp 6/22/2009 12:00'!
primSetSemaphoreIndexDigitalInputChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDigitalInputChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalInput_SetSemaphoreIndex_StateChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Digital Output' stamp: 'sp 6/22/2009 12:02'!
primSetSemaphoreIndexDigitalOutputChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexDigitalOutputChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompDigitalOutput_SetSemaphoreIndex_StateChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/15/2009 12:45'!
primSetSemaphoreIndexError: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexError' parameters: #(SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidget_SetSemaphoreIndex_Error(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/26/2009 06:29'!
primSetSemaphoreIndexMotorCurrentChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexMotorCurrentChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompMotor_SetSemaphoreIndex_CurrentChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Motor' stamp: 'sp 6/26/2009 06:29'!
primSetSemaphoreIndexMotorVelocityChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexMotorVelocityChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompMotor_SetSemaphoreIndex_VelocityChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 17:46'!
primSetSemaphoreIndexRFIDTagFound: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexRFIDTagFound' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_SetSemaphoreIndex_TagFound(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: RFID' stamp: 'lk 6/15/2009 17:46'!
primSetSemaphoreIndexRFIDTagLost: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexRFIDTagLost' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompRFID_SetSemaphoreIndex_TagLost(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:33'!
primSetSemaphoreIndexServoPositionChange: semaIndex for: phidgetIdArray

	| phidgetId |
	self primitive: 'primSetSemaphoreIndexServoPositionChange' parameters: #(SmallInteger Oop).
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_SetSemaphoreIndex_PositionChange(phidgetId, semaIndex)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'sp 6/29/2009 10:45'!
primSetServoEngaged: phidgetIdArray at: index to: state

	| phidgetId |
	self primitive: 'primSetServoEngaged' parameters: #(Oop SmallInteger SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_SetEngaged(phidgetId, index, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Servo Motor' stamp: 'lk 6/15/2009 22:34'!
primSetServoPosition: phidgetIdArray at: index to: position

	| phidgetId floatPosition |
	self primitive: 'primSetServoPosition' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #floatValue type: 'double'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	floatPosition := interpreterProxy floatValueOf: position.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompServoMotor_SetPosition(phidgetId, index, floatPosition)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: Simple LED' stamp: 'lk 6/15/2009 20:38'!
primSetSimpleLEDState: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetSimpleLEDState' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompSimpleLED_SetState(phidgetId, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'fs 7/5/2009 23:42'!
primSetTextDisplayCharacter: phidgetIdArray in: row and: column to: charStringArray

	| phidgetId character |
	self primitive: 'primSetTextDisplayCharacter' parameters: #(Oop SmallInteger SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #character type: 'char'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	
	(interpreterProxy stSizeOf: charStringArray) ~= 1 ifTrue: [ ^ nil ].
	character := ( self
		cCoerce: (interpreterProxy arrayValueOf: charStringArray)
		to: 'char*' ) at: 0.
	
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompTextLCD_DisplayCharacter(phidgetId, row, column, character)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextDisplay' stamp: 'fs 7/5/2009 22:23'!
primSetTextDisplayString: phidgetIdArray in: row to: stringArray

	| phidgetId string size |
	self primitive: 'primSetTextDisplayString' parameters: #(Oop SmallInteger Oop).
	self var: #phidgetId type: 'PhidgetId'.
	self var: #string type: 'char*'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	
	string := self cCoerce: (interpreterProxy arrayValueOf: stringArray) to: 'char*'.
	size := interpreterProxy stSizeOf: stringArray.
	
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf:
			( self cCode: 'phidgetCompTextLCD_DisplayString(phidgetId, row, string, size)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:03'!
primSetTextLCDBacklightOn: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetTextLCDBacklightOn' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetBacklightOn(phidgetId, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:10'!
primSetTextLCDContrast: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetTextLCDContrast' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetContrast(phidgetId, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Component: TextLCD' stamp: 'fs 7/5/2009 20:36'!
primSetTextLCDCursorBlinking: phidgetIdArray to: state

	| phidgetId |
	self primitive: 'primSetTextLCDCursorBlinking' parameters: #(Oop SmallInteger).
	self var: #phidgetId type: 'PhidgetId'.
	
	phidgetId := self cCode: '*phidgetIdOf(phidgetIdArray)'.
	interpreterProxy failed ifFalse: [
		^ interpreterProxy integerObjectOf: ( self cCode: 'phidgetCompTextLCD_SetCursorBlinking(phidgetId, state)' ) ].
	^ nil! !

!PhidgetPlugin methodsFor: 'Phidget: TextLCD' stamp: 'fs 7/5/2009 18:40'!
primTextLCDCreate

	self primitive: 'primTextLCDCreate' parameters: #().
	^ self cCode: 'phidgetTextLCD_Create()'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'lk 6/14/2009 18:14'!
shutdownModule
	"Shutdown the module"
	
	self export: true.
	self cCode: 'phidgetPlugin_Shutdown()'.
	^ 1! !
